
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "qpid/agent/ManagementAgent.h"
#include "Collector.h"


using namespace qmf::mrg::grid;
using namespace qpid::framing;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           std::string;

string  Collector::packageName  = string ("mrg.grid");
string  Collector::className    = string ("collector");
uint8_t Collector::md5Sum[16]   =
    {0x7e,0x71,0x4b,0xb0,0x27,0x1f,0x3f,0x3b,0x79,0xb8,0xc0,0x65,0x18,0x3c,0x36,0xd1};

Collector::Collector (ManagementAgent* _agent, Manageable* _core) :
    ManagementObject(_agent, _core)
{
    
    Pool = "";
    System = "";
    CondorPlatform = "";
    CondorVersion = "";
    Name = "";
    PublicNetworkIpAddr = "";
    RunningJobs = 0;
    IdleJobs = 0;
    HostsTotal = 0;
    HostsClaimed = 0;
    HostsUnclaimed = 0;
    HostsOwner = 0;



}

Collector::~Collector ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Collector::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Collector::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (6); // Config Element Count
    buf.putShort       (6); // Inst Element Count
    buf.putShort       (0); // Method Count

    // Properties
    ft.clear();
    ft.setString (NAME, "Pool");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "System");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "CondorPlatform");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "CondorVersion");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Name");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "PublicNetworkIpAddr");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);


    // Statistics
    ft.clear();
    ft.setString (NAME,   "RunningJobs");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "IdleJobs");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "HostsTotal");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "HostsClaimed");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "HostsUnclaimed");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "HostsOwner");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);


    // Methods

}



void Collector::writeProperties (Buffer& buf)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);

    buf.putShortString(Pool);
    buf.putShortString(System);
    buf.putShortString(CondorPlatform);
    buf.putShortString(CondorVersion);
    buf.putShortString(Name);
    buf.putShortString(PublicNetworkIpAddr);

}

void Collector::writeStatistics (Buffer& buf, bool skipHeaders)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders)
        writeTimestamps (buf);
    buf.putLong(RunningJobs);
    buf.putLong(IdleJobs);
    buf.putLong(HostsTotal);
    buf.putLong(HostsClaimed);
    buf.putLong(HostsUnclaimed);
    buf.putLong(HostsOwner);


    // Maintenance of hi-lo statistics


}

void Collector::doMethod (string&, Buffer&, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    outBuf.putLong(status);
    outBuf.putShortString(Manageable::StatusText(status, text));
}
