
#ifndef _MANAGEMENT_COLLECTOR_
#define _MANAGEMENT_COLLECTOR_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/Uuid.h"

namespace qmf {
namespace mrg {
namespace grid {


class Collector : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[16];


    // Properties
    std::string Pool;
    std::string System;
    std::string CondorPlatform;
    std::string CondorVersion;
    std::string Name;
    std::string PublicNetworkIpAddr;

    // Statistics
    uint32_t  RunningJobs;
    uint32_t  IdleJobs;
    uint32_t  HostsTotal;
    uint32_t  HostsClaimed;
    uint32_t  HostsUnclaimed;
    uint32_t  HostsOwner;


    // Private Methods
    static void writeSchema(::qpid::framing::Buffer& buf);
    void writeProperties(::qpid::framing::Buffer& buf);
    void writeStatistics(::qpid::framing::Buffer& buf,
                         bool skipHeaders = false);
    void doMethod(std::string& methodName,
                  ::qpid::framing::Buffer& inBuf,
                  ::qpid::framing::Buffer& outBuf);
    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }

  public:

    Collector(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject);
    ~Collector();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs

    // Accessor Methods
    inline void set_Pool (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        Pool = val;
        configChanged = true;
    }
    inline const std::string& get_Pool() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return Pool;
    }
    inline void set_System (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        System = val;
        configChanged = true;
    }
    inline const std::string& get_System() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return System;
    }
    inline void set_CondorPlatform (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        CondorPlatform = val;
        configChanged = true;
    }
    inline const std::string& get_CondorPlatform() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return CondorPlatform;
    }
    inline void set_CondorVersion (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        CondorVersion = val;
        configChanged = true;
    }
    inline const std::string& get_CondorVersion() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return CondorVersion;
    }
    inline void set_Name (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        Name = val;
        configChanged = true;
    }
    inline const std::string& get_Name() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return Name;
    }
    inline void set_PublicNetworkIpAddr (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        PublicNetworkIpAddr = val;
        configChanged = true;
    }
    inline const std::string& get_PublicNetworkIpAddr() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return PublicNetworkIpAddr;
    }
    inline void set_RunningJobs (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        RunningJobs = val;
        instChanged = true;
    }
    inline uint32_t get_RunningJobs() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return RunningJobs;
    }
    inline void set_IdleJobs (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        IdleJobs = val;
        instChanged = true;
    }
    inline uint32_t get_IdleJobs() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return IdleJobs;
    }
    inline void set_HostsTotal (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        HostsTotal = val;
        instChanged = true;
    }
    inline uint32_t get_HostsTotal() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return HostsTotal;
    }
    inline void set_HostsClaimed (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        HostsClaimed = val;
        instChanged = true;
    }
    inline uint32_t get_HostsClaimed() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return HostsClaimed;
    }
    inline void set_HostsUnclaimed (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        HostsUnclaimed = val;
        instChanged = true;
    }
    inline uint32_t get_HostsUnclaimed() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return HostsUnclaimed;
    }
    inline void set_HostsOwner (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        HostsOwner = val;
        instChanged = true;
    }
    inline uint32_t get_HostsOwner() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return HostsOwner;
    }

};

}}}

#endif  /*!_MANAGEMENT_COLLECTOR_*/
