
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "qpid/agent/ManagementAgent.h"
#include "Grid.h"


using namespace qmf::mrg::grid;
using namespace qpid::framing;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           std::string;

string  Grid::packageName  = string ("mrg.grid");
string  Grid::className    = string ("grid");
uint8_t Grid::md5Sum[16]   =
    {0xf4,0xd8,0x7,0xc4,0x69,0x2a,0xaf,0x1,0xa9,0x24,0x6e,0xf0,0x35,0x1c,0x57,0x8};

Grid::Grid (ManagementAgent* _agent, Manageable* _core) :
    ManagementObject(_agent, _core)
{
    
    Pool = "";
    Name = "";
    ScheddName = "";
    Owner = "";
    JobLimit = 0;
    SubmitLimit = 0;
    GridResourceUnavailableTime = 0;
    NumJobs = 0;
    SubmitsInProgress = 0;
    SubmitsQueued = 0;
    SubmitsAllowed = 0;
    SubmitsWanted = 0;
    RunningJobs = 0;
    IdleJobs = 0;


    // Optional properties start out not-present
    for (uint8_t idx = 0; idx < 1; idx++)
        presenceMask[idx] = 0;


}

Grid::~Grid ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Grid::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Grid::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (7); // Config Element Count
    buf.putShort       (7); // Inst Element Count
    buf.putShort       (0); // Method Count

    // Properties
    ft.clear();
    ft.setString (NAME, "Pool");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Name");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "ScheddName");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Owner");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "JobLimit");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Maximum number of jobs that can be in the process       of being submitted at any time.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "SubmitLimit");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Limit on the number of jobs that will be submitted       to the grid resource at once.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "GridResourceUnavailableTime");
    ft.setInt    (TYPE, TYPE_ABSTIME);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (UNIT,   "nanosecond");
    ft.setString (DESC,   "If present, the Grid is down for the specified       amount of time.");
    buf.put (ft);


    // Statistics
    ft.clear();
    ft.setString (NAME,   "NumJobs");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "SubmitsInProgress");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "SubmitsQueued");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "SubmitsAllowed");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "SubmitsWanted");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "RunningJobs");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "IdleJobs");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);


    // Methods

}



void Grid::writeProperties (Buffer& buf)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);

    for (uint8_t idx = 0; idx < 1; idx++)
        buf.putOctet(presenceMask[idx]);

    buf.putShortString(Pool);
    buf.putShortString(Name);
    buf.putShortString(ScheddName);
    buf.putShortString(Owner);
    buf.putLong(JobLimit);
    buf.putLong(SubmitLimit);
    if (presenceMask[presenceByte_GridResourceUnavailableTime] & presenceMask_GridResourceUnavailableTime) {
        buf.putLongLong(GridResourceUnavailableTime);
    }

}

void Grid::writeStatistics (Buffer& buf, bool skipHeaders)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders)
        writeTimestamps (buf);
    buf.putLong(NumJobs);
    buf.putLong(SubmitsInProgress);
    buf.putLong(SubmitsQueued);
    buf.putLong(SubmitsAllowed);
    buf.putLong(SubmitsWanted);
    buf.putLong(RunningJobs);
    buf.putLong(IdleJobs);


    // Maintenance of hi-lo statistics


}

void Grid::doMethod (string&, Buffer&, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    outBuf.putLong(status);
    outBuf.putShortString(Manageable::StatusText(status, text));
}
