/*
 * Copyright 2008 Red Hat, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef _GRIDOBJECT_H
#define _GRIDOBJECT_H

#include <qpid/management/Manageable.h>
#include <qpid/management/ManagementObject.h>
#include <qpid/agent/ManagementAgent.h>

#include "Grid.h"


namespace mrg {
namespace grid {

using namespace qpid::management;
using namespace qmf::mrg::grid;

class GridObject : public Manageable
{
public:

	GridObject(ManagementAgent *agent);

	~GridObject();

	ManagementObject *GetManagementObject(void) const;

	void update(const ClassAd &ad);

private:

	Grid *mgmtObject;

};

}} /* mrg::grid */

#endif /* _GRIDOBJECT_H */
