
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "qpid/agent/ManagementAgent.h"
#include "Job.h"
#include "ArgsJobGetAd.h"
#include "ArgsJobSetAttribute.h"
#include "ArgsJobHold.h"
#include "ArgsJobRelease.h"
#include "ArgsJobRemove.h"
#include "ArgsJobFetch.h"


using namespace qmf::mrg::grid;
using namespace qpid::framing;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           std::string;

string  Job::packageName  = string ("mrg.grid");
string  Job::className    = string ("job");
uint8_t Job::md5Sum[16]   =
    {0xc9,0x74,0x4f,0xfa,0x59,0xe1,0x65,0xa6,0x30,0x2,0xda,0xd5,0xa1,0x6d,0xeb,0x2a};

Job::Job (ManagementAgent* _agent, Manageable* _core, ::qpid::management::Manageable* _parent) :
    ManagementObject(_agent, _core)
{
    schedulerRef = _parent->GetManagementObject ()->getObjectId ();
    submitterRef = ::qpid::management::ObjectId();
    AccountingGroup = "";
    Args = "";
    ClusterId = 0;
    Cmd = "";
    ConcurrencyLimits = "";
    CustomGroup = "";
    CustomId = "";
    CustomPriority = 0;
    GlobalJobId = "";
    In = "";
    Iwd = "";
    JobStatus = 0;
    Note = "";
    Out = "";
    Owner = "";
    User = "";
    ProcId = 0;
    QDate = 0;
    JobUniverse = 0;
    Title = "";
    UserLog = "";
    HoldReason = "";
    DAGNodeName = "";
    DAGParentNodeNames = "";
    DAGManJobId = 0;
    Ad = ::qpid::framing::FieldTable();


    // Optional properties start out not-present
    for (uint8_t idx = 0; idx < 2; idx++)
        presenceMask[idx] = 0;


}

Job::~Job ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Job::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Job::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (28); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (6); // Method Count

    // Properties
    ft.clear();
    ft.setString (NAME, "schedulerRef");
    ft.setInt    (TYPE, TYPE_REF);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "submitterRef");
    ft.setInt    (TYPE, TYPE_REF);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "AccountingGroup");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Args");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "ClusterId");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The id of the cluster the job belongs       to. ClusterIds are unique within a SchedD.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Cmd");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "ConcurrencyLimits");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "CustomGroup");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "CustomId");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "CustomPriority");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "GlobalJobId");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "In");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The file where the job's standard input is read       from.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Iwd");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "JobStatus");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "One of: 0, unexpanded; 1, idle; 2, running; 3,       removed; 4, completed; 5, held; or, 6, submission       error");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Note");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "An arbitrary note attached to the job.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Out");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The file where the job's standard output is       written.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Owner");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The submitter of the job.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "User");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The Owner '@' the configured UidDomain namespace");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "ProcId");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The id of the job within its cluster. ProcIds re       unique within a cluster.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "QDate");
    ft.setInt    (TYPE, TYPE_ABSTIME);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "nanoseconds");
    ft.setString (DESC,   "The number of nanoseconds since epoch when the       job was submitted.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "JobUniverse");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Title");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "UserLog");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "HoldReason");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "DAGNodeName");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "DAGParentNodeNames");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "Comma separated list of the job's parent's node       names");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "DAGManJobId");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "The ClusterId of the DAGMan job who spawned the       job");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Ad");
    ft.setInt    (TYPE, TYPE_FTABLE);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "");
    buf.put (ft);


    // Statistics

    // Methods
    ft.clear();
    ft.setString (NAME,     "GetAd");
    ft.setInt    (ARGCOUNT, 1);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "JobAd");
    ft.setInt    (TYPE,    TYPE_FTABLE);
    ft.setString (DIR,     "O");
    ft.setString (DESC,    "(name,value,type) tuples; Values are INTEGER, FLOAT,    STRING and EXPR. The EXPR value is not first class,    it is an unquoted, with double quotes, string");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "SetAttribute");
    ft.setInt    (ARGCOUNT, 2);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Name");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Value");
    ft.setInt    (TYPE,    TYPE_LSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "Hold");
    ft.setInt    (ARGCOUNT, 1);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Reason");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "Release");
    ft.setInt    (ARGCOUNT, 1);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Reason");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "Remove");
    ft.setInt    (ARGCOUNT, 1);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Reason");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "Fetch");
    ft.setInt    (ARGCOUNT, 4);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "File");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Start");
    ft.setInt    (TYPE,    TYPE_S32);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "End");
    ft.setInt    (TYPE,    TYPE_S32);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Data");
    ft.setInt    (TYPE,    TYPE_LSTR);
    ft.setString (DIR,     "O");
    buf.put (ft);


}



void Job::writeProperties (Buffer& buf)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);

    for (uint8_t idx = 0; idx < 2; idx++)
        buf.putOctet(presenceMask[idx]);

    schedulerRef.encode(buf);
    submitterRef.encode(buf);
    if (presenceMask[presenceByte_AccountingGroup] & presenceMask_AccountingGroup) {
        buf.putShortString(AccountingGroup);
    }
    if (presenceMask[presenceByte_Args] & presenceMask_Args) {
        buf.putMediumString(Args);
    }
    buf.putLong(ClusterId);
    buf.putMediumString(Cmd);
    if (presenceMask[presenceByte_ConcurrencyLimits] & presenceMask_ConcurrencyLimits) {
        buf.putMediumString(ConcurrencyLimits);
    }
    if (presenceMask[presenceByte_CustomGroup] & presenceMask_CustomGroup) {
        buf.putShortString(CustomGroup);
    }
    if (presenceMask[presenceByte_CustomId] & presenceMask_CustomId) {
        buf.putShortString(CustomId);
    }
    if (presenceMask[presenceByte_CustomPriority] & presenceMask_CustomPriority) {
        buf.putLong(CustomPriority);
    }
    buf.putShortString(GlobalJobId);
    buf.putMediumString(In);
    buf.putMediumString(Iwd);
    buf.putLong(JobStatus);
    if (presenceMask[presenceByte_Note] & presenceMask_Note) {
        buf.putMediumString(Note);
    }
    buf.putMediumString(Out);
    buf.putShortString(Owner);
    buf.putShortString(User);
    buf.putLong(ProcId);
    buf.putLongLong(QDate);
    buf.putLong(JobUniverse);
    if (presenceMask[presenceByte_Title] & presenceMask_Title) {
        buf.putShortString(Title);
    }
    if (presenceMask[presenceByte_UserLog] & presenceMask_UserLog) {
        buf.putMediumString(UserLog);
    }
    if (presenceMask[presenceByte_HoldReason] & presenceMask_HoldReason) {
        buf.putMediumString(HoldReason);
    }
    if (presenceMask[presenceByte_DAGNodeName] & presenceMask_DAGNodeName) {
        buf.putShortString(DAGNodeName);
    }
    if (presenceMask[presenceByte_DAGParentNodeNames] & presenceMask_DAGParentNodeNames) {
        buf.putMediumString(DAGParentNodeNames);
    }
    if (presenceMask[presenceByte_DAGManJobId] & presenceMask_DAGManJobId) {
        buf.putLong(DAGManJobId);
    }
    if (presenceMask[presenceByte_Ad] & presenceMask_Ad) {
        Ad.encode(buf);
    }

}

void Job::writeStatistics (Buffer& buf, bool skipHeaders)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders)
        writeTimestamps (buf);


    // Maintenance of hi-lo statistics


}

void Job::doMethod (string& methodName, Buffer& inBuf, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "GetAd") {
        ArgsJobGetAd ioArgs;
        status = coreObject->ManagementMethod (METHOD_GETAD, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        ioArgs.o_JobAd.encode(outBuf);
        return;
    }

    if (methodName == "SetAttribute") {
        ArgsJobSetAttribute ioArgs;
        inBuf.getShortString(ioArgs.i_Name);
        inBuf.getMediumString(ioArgs.i_Value);
        status = coreObject->ManagementMethod (METHOD_SETATTRIBUTE, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "Hold") {
        ArgsJobHold ioArgs;
        inBuf.getShortString(ioArgs.i_Reason);
        status = coreObject->ManagementMethod (METHOD_HOLD, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "Release") {
        ArgsJobRelease ioArgs;
        inBuf.getShortString(ioArgs.i_Reason);
        status = coreObject->ManagementMethod (METHOD_RELEASE, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "Remove") {
        ArgsJobRemove ioArgs;
        inBuf.getShortString(ioArgs.i_Reason);
        status = coreObject->ManagementMethod (METHOD_REMOVE, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "Fetch") {
        ArgsJobFetch ioArgs;
        inBuf.getShortString(ioArgs.i_File);
        ioArgs.i_Start = inBuf.getInt32();
        ioArgs.i_End = inBuf.getInt32();
        status = coreObject->ManagementMethod (METHOD_FETCH, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        outBuf.putMediumString(ioArgs.o_Data);
        return;
    }

    outBuf.putLong(status);
    outBuf.putShortString(Manageable::StatusText(status, text));
}
