
#ifndef _MANAGEMENT_JOB_
#define _MANAGEMENT_JOB_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/Uuid.h"

namespace qmf {
namespace mrg {
namespace grid {


class Job : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[16];

    uint8_t presenceMask[2];
    static const uint8_t presenceByte_AccountingGroup = 0;
    static const uint8_t presenceMask_AccountingGroup = 1;
    static const uint8_t presenceByte_Args = 0;
    static const uint8_t presenceMask_Args = 2;
    static const uint8_t presenceByte_ConcurrencyLimits = 0;
    static const uint8_t presenceMask_ConcurrencyLimits = 4;
    static const uint8_t presenceByte_CustomGroup = 0;
    static const uint8_t presenceMask_CustomGroup = 8;
    static const uint8_t presenceByte_CustomId = 0;
    static const uint8_t presenceMask_CustomId = 16;
    static const uint8_t presenceByte_CustomPriority = 0;
    static const uint8_t presenceMask_CustomPriority = 32;
    static const uint8_t presenceByte_Note = 0;
    static const uint8_t presenceMask_Note = 64;
    static const uint8_t presenceByte_Title = 0;
    static const uint8_t presenceMask_Title = 128;
    static const uint8_t presenceByte_UserLog = 1;
    static const uint8_t presenceMask_UserLog = 1;
    static const uint8_t presenceByte_HoldReason = 1;
    static const uint8_t presenceMask_HoldReason = 2;
    static const uint8_t presenceByte_DAGNodeName = 1;
    static const uint8_t presenceMask_DAGNodeName = 4;
    static const uint8_t presenceByte_DAGParentNodeNames = 1;
    static const uint8_t presenceMask_DAGParentNodeNames = 8;
    static const uint8_t presenceByte_DAGManJobId = 1;
    static const uint8_t presenceMask_DAGManJobId = 16;
    static const uint8_t presenceByte_Ad = 1;
    static const uint8_t presenceMask_Ad = 32;



    // Properties
    ::qpid::management::ObjectId schedulerRef;
    ::qpid::management::ObjectId submitterRef;
    std::string AccountingGroup;
    std::string Args;
    uint32_t ClusterId;
    std::string Cmd;
    std::string ConcurrencyLimits;
    std::string CustomGroup;
    std::string CustomId;
    uint32_t CustomPriority;
    std::string GlobalJobId;
    std::string In;
    std::string Iwd;
    uint32_t JobStatus;
    std::string Note;
    std::string Out;
    std::string Owner;
    std::string User;
    uint32_t ProcId;
    int64_t QDate;
    uint32_t JobUniverse;
    std::string Title;
    std::string UserLog;
    std::string HoldReason;
    std::string DAGNodeName;
    std::string DAGParentNodeNames;
    uint32_t DAGManJobId;
    ::qpid::framing::FieldTable Ad;

    // Statistics


    // Private Methods
    static void writeSchema(::qpid::framing::Buffer& buf);
    void writeProperties(::qpid::framing::Buffer& buf);
    void writeStatistics(::qpid::framing::Buffer& buf,
                         bool skipHeaders = false);
    void doMethod(std::string& methodName,
                  ::qpid::framing::Buffer& inBuf,
                  ::qpid::framing::Buffer& outBuf);
    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }

    // Stub for getInstChanged.  There are no statistics in this class.
    bool getInstChanged() { return false; }
    bool hasInst() { return false; }

  public:

    Job(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject, ::qpid::management::Manageable* _parent);
    ~Job();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_GETAD = 1;
    static const uint32_t METHOD_SETATTRIBUTE = 2;
    static const uint32_t METHOD_HOLD = 3;
    static const uint32_t METHOD_RELEASE = 4;
    static const uint32_t METHOD_REMOVE = 5;
    static const uint32_t METHOD_FETCH = 6;

    // Accessor Methods
    inline void set_schedulerRef (const ::qpid::management::ObjectId& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        schedulerRef = val;
        configChanged = true;
    }
    inline const ::qpid::management::ObjectId& get_schedulerRef() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return schedulerRef;
    }
    inline void set_submitterRef (const ::qpid::management::ObjectId& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        submitterRef = val;
        configChanged = true;
    }
    inline const ::qpid::management::ObjectId& get_submitterRef() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return submitterRef;
    }
    inline void set_AccountingGroup (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        AccountingGroup = val;
        presenceMask[presenceByte_AccountingGroup] |= presenceMask_AccountingGroup;
        configChanged = true;
    }
    inline const std::string& get_AccountingGroup() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return AccountingGroup;
    }
    inline void clr_AccountingGroup() {
        presenceMask[presenceByte_AccountingGroup] &= ~presenceMask_AccountingGroup;
        configChanged = true;
    }
    inline bool isSet_AccountingGroup() {
        return (presenceMask[presenceByte_AccountingGroup] & presenceMask_AccountingGroup) != 0;
    }
    inline void set_Args (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        Args = val;
        presenceMask[presenceByte_Args] |= presenceMask_Args;
        configChanged = true;
    }
    inline const std::string& get_Args() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return Args;
    }
    inline void clr_Args() {
        presenceMask[presenceByte_Args] &= ~presenceMask_Args;
        configChanged = true;
    }
    inline bool isSet_Args() {
        return (presenceMask[presenceByte_Args] & presenceMask_Args) != 0;
    }
    inline void set_ClusterId (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        ClusterId = val;
        configChanged = true;
    }
    inline uint32_t get_ClusterId() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return ClusterId;
    }
    inline void set_Cmd (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        Cmd = val;
        configChanged = true;
    }
    inline const std::string& get_Cmd() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return Cmd;
    }
    inline void set_ConcurrencyLimits (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        ConcurrencyLimits = val;
        presenceMask[presenceByte_ConcurrencyLimits] |= presenceMask_ConcurrencyLimits;
        configChanged = true;
    }
    inline const std::string& get_ConcurrencyLimits() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return ConcurrencyLimits;
    }
    inline void clr_ConcurrencyLimits() {
        presenceMask[presenceByte_ConcurrencyLimits] &= ~presenceMask_ConcurrencyLimits;
        configChanged = true;
    }
    inline bool isSet_ConcurrencyLimits() {
        return (presenceMask[presenceByte_ConcurrencyLimits] & presenceMask_ConcurrencyLimits) != 0;
    }
    inline void set_CustomGroup (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        CustomGroup = val;
        presenceMask[presenceByte_CustomGroup] |= presenceMask_CustomGroup;
        configChanged = true;
    }
    inline const std::string& get_CustomGroup() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return CustomGroup;
    }
    inline void clr_CustomGroup() {
        presenceMask[presenceByte_CustomGroup] &= ~presenceMask_CustomGroup;
        configChanged = true;
    }
    inline bool isSet_CustomGroup() {
        return (presenceMask[presenceByte_CustomGroup] & presenceMask_CustomGroup) != 0;
    }
    inline void set_CustomId (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        CustomId = val;
        presenceMask[presenceByte_CustomId] |= presenceMask_CustomId;
        configChanged = true;
    }
    inline const std::string& get_CustomId() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return CustomId;
    }
    inline void clr_CustomId() {
        presenceMask[presenceByte_CustomId] &= ~presenceMask_CustomId;
        configChanged = true;
    }
    inline bool isSet_CustomId() {
        return (presenceMask[presenceByte_CustomId] & presenceMask_CustomId) != 0;
    }
    inline void set_CustomPriority (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        CustomPriority = val;
        presenceMask[presenceByte_CustomPriority] |= presenceMask_CustomPriority;
        configChanged = true;
    }
    inline uint32_t get_CustomPriority() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return CustomPriority;
    }
    inline void clr_CustomPriority() {
        presenceMask[presenceByte_CustomPriority] &= ~presenceMask_CustomPriority;
        configChanged = true;
    }
    inline bool isSet_CustomPriority() {
        return (presenceMask[presenceByte_CustomPriority] & presenceMask_CustomPriority) != 0;
    }
    inline void set_GlobalJobId (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        GlobalJobId = val;
        configChanged = true;
    }
    inline const std::string& get_GlobalJobId() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return GlobalJobId;
    }
    inline void set_In (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        In = val;
        configChanged = true;
    }
    inline const std::string& get_In() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return In;
    }
    inline void set_Iwd (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        Iwd = val;
        configChanged = true;
    }
    inline const std::string& get_Iwd() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return Iwd;
    }
    inline void set_JobStatus (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        JobStatus = val;
        configChanged = true;
    }
    inline uint32_t get_JobStatus() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return JobStatus;
    }
    inline void set_Note (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        Note = val;
        presenceMask[presenceByte_Note] |= presenceMask_Note;
        configChanged = true;
    }
    inline const std::string& get_Note() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return Note;
    }
    inline void clr_Note() {
        presenceMask[presenceByte_Note] &= ~presenceMask_Note;
        configChanged = true;
    }
    inline bool isSet_Note() {
        return (presenceMask[presenceByte_Note] & presenceMask_Note) != 0;
    }
    inline void set_Out (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        Out = val;
        configChanged = true;
    }
    inline const std::string& get_Out() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return Out;
    }
    inline void set_Owner (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        Owner = val;
        configChanged = true;
    }
    inline const std::string& get_Owner() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return Owner;
    }
    inline void set_User (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        User = val;
        configChanged = true;
    }
    inline const std::string& get_User() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return User;
    }
    inline void set_ProcId (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        ProcId = val;
        configChanged = true;
    }
    inline uint32_t get_ProcId() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return ProcId;
    }
    inline void set_QDate (int64_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        QDate = val;
        configChanged = true;
    }
    inline int64_t get_QDate() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return QDate;
    }
    inline void set_JobUniverse (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        JobUniverse = val;
        configChanged = true;
    }
    inline uint32_t get_JobUniverse() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return JobUniverse;
    }
    inline void set_Title (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        Title = val;
        presenceMask[presenceByte_Title] |= presenceMask_Title;
        configChanged = true;
    }
    inline const std::string& get_Title() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return Title;
    }
    inline void clr_Title() {
        presenceMask[presenceByte_Title] &= ~presenceMask_Title;
        configChanged = true;
    }
    inline bool isSet_Title() {
        return (presenceMask[presenceByte_Title] & presenceMask_Title) != 0;
    }
    inline void set_UserLog (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        UserLog = val;
        presenceMask[presenceByte_UserLog] |= presenceMask_UserLog;
        configChanged = true;
    }
    inline const std::string& get_UserLog() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return UserLog;
    }
    inline void clr_UserLog() {
        presenceMask[presenceByte_UserLog] &= ~presenceMask_UserLog;
        configChanged = true;
    }
    inline bool isSet_UserLog() {
        return (presenceMask[presenceByte_UserLog] & presenceMask_UserLog) != 0;
    }
    inline void set_HoldReason (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        HoldReason = val;
        presenceMask[presenceByte_HoldReason] |= presenceMask_HoldReason;
        configChanged = true;
    }
    inline const std::string& get_HoldReason() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return HoldReason;
    }
    inline void clr_HoldReason() {
        presenceMask[presenceByte_HoldReason] &= ~presenceMask_HoldReason;
        configChanged = true;
    }
    inline bool isSet_HoldReason() {
        return (presenceMask[presenceByte_HoldReason] & presenceMask_HoldReason) != 0;
    }
    inline void set_DAGNodeName (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        DAGNodeName = val;
        presenceMask[presenceByte_DAGNodeName] |= presenceMask_DAGNodeName;
        configChanged = true;
    }
    inline const std::string& get_DAGNodeName() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return DAGNodeName;
    }
    inline void clr_DAGNodeName() {
        presenceMask[presenceByte_DAGNodeName] &= ~presenceMask_DAGNodeName;
        configChanged = true;
    }
    inline bool isSet_DAGNodeName() {
        return (presenceMask[presenceByte_DAGNodeName] & presenceMask_DAGNodeName) != 0;
    }
    inline void set_DAGParentNodeNames (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        DAGParentNodeNames = val;
        presenceMask[presenceByte_DAGParentNodeNames] |= presenceMask_DAGParentNodeNames;
        configChanged = true;
    }
    inline const std::string& get_DAGParentNodeNames() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return DAGParentNodeNames;
    }
    inline void clr_DAGParentNodeNames() {
        presenceMask[presenceByte_DAGParentNodeNames] &= ~presenceMask_DAGParentNodeNames;
        configChanged = true;
    }
    inline bool isSet_DAGParentNodeNames() {
        return (presenceMask[presenceByte_DAGParentNodeNames] & presenceMask_DAGParentNodeNames) != 0;
    }
    inline void set_DAGManJobId (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        DAGManJobId = val;
        presenceMask[presenceByte_DAGManJobId] |= presenceMask_DAGManJobId;
        configChanged = true;
    }
    inline uint32_t get_DAGManJobId() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return DAGManJobId;
    }
    inline void clr_DAGManJobId() {
        presenceMask[presenceByte_DAGManJobId] &= ~presenceMask_DAGManJobId;
        configChanged = true;
    }
    inline bool isSet_DAGManJobId() {
        return (presenceMask[presenceByte_DAGManJobId] & presenceMask_DAGManJobId) != 0;
    }
    inline void set_Ad (const ::qpid::framing::FieldTable& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        Ad = val;
        presenceMask[presenceByte_Ad] |= presenceMask_Ad;
        configChanged = true;
    }
    inline const ::qpid::framing::FieldTable& get_Ad() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return Ad;
    }
    inline void clr_Ad() {
        presenceMask[presenceByte_Ad] &= ~presenceMask_Ad;
        configChanged = true;
    }
    inline bool isSet_Ad() {
        return (presenceMask[presenceByte_Ad] & presenceMask_Ad) != 0;
    }

};

}}}

#endif  /*!_MANAGEMENT_JOB_*/
