
#ifndef _MANAGEMENT_MASTER_
#define _MANAGEMENT_MASTER_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/Uuid.h"

namespace qmf {
namespace mrg {
namespace grid {


class Master : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[16];


    // Properties
    std::string CondorPlatform;
    std::string CondorVersion;
    int64_t DaemonStartTime;
    std::string Pool;
    std::string System;
    std::string Name;
    std::string Machine;
    std::string PublicNetworkIpAddr;
    std::string MyAddress;
    int32_t RealUid;

    // Statistics
    uint32_t  MonitorSelfAge;
    double  MonitorSelfCPUUsage;
    double  MonitorSelfImageSize;
    uint32_t  MonitorSelfRegisteredSocketCount;
    uint32_t  MonitorSelfResidentSetSize;
    int64_t  MonitorSelfTime;


    // Private Methods
    static void writeSchema(::qpid::framing::Buffer& buf);
    void writeProperties(::qpid::framing::Buffer& buf);
    void writeStatistics(::qpid::framing::Buffer& buf,
                         bool skipHeaders = false);
    void doMethod(std::string& methodName,
                  ::qpid::framing::Buffer& inBuf,
                  ::qpid::framing::Buffer& outBuf);
    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }

  public:

    Master(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject);
    ~Master();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_START = 1;
    static const uint32_t METHOD_STOP = 2;

    // Accessor Methods
    inline void set_CondorPlatform (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        CondorPlatform = val;
        configChanged = true;
    }
    inline const std::string& get_CondorPlatform() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return CondorPlatform;
    }
    inline void set_CondorVersion (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        CondorVersion = val;
        configChanged = true;
    }
    inline const std::string& get_CondorVersion() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return CondorVersion;
    }
    inline void set_DaemonStartTime (int64_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        DaemonStartTime = val;
        configChanged = true;
    }
    inline int64_t get_DaemonStartTime() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return DaemonStartTime;
    }
    inline void set_Pool (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        Pool = val;
        configChanged = true;
    }
    inline const std::string& get_Pool() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return Pool;
    }
    inline void set_System (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        System = val;
        configChanged = true;
    }
    inline const std::string& get_System() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return System;
    }
    inline void set_Name (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        Name = val;
        configChanged = true;
    }
    inline const std::string& get_Name() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return Name;
    }
    inline void set_Machine (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        Machine = val;
        configChanged = true;
    }
    inline const std::string& get_Machine() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return Machine;
    }
    inline void set_PublicNetworkIpAddr (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        PublicNetworkIpAddr = val;
        configChanged = true;
    }
    inline const std::string& get_PublicNetworkIpAddr() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return PublicNetworkIpAddr;
    }
    inline void set_MyAddress (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        MyAddress = val;
        configChanged = true;
    }
    inline const std::string& get_MyAddress() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return MyAddress;
    }
    inline void set_RealUid (int32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        RealUid = val;
        configChanged = true;
    }
    inline int32_t get_RealUid() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return RealUid;
    }
    inline void set_MonitorSelfAge (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfAge = val;
        instChanged = true;
    }
    inline uint32_t get_MonitorSelfAge() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfAge;
    }
    inline void set_MonitorSelfCPUUsage (double val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfCPUUsage = val;
        instChanged = true;
    }
    inline double get_MonitorSelfCPUUsage() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfCPUUsage;
    }
    inline void set_MonitorSelfImageSize (double val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfImageSize = val;
        instChanged = true;
    }
    inline double get_MonitorSelfImageSize() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfImageSize;
    }
    inline void set_MonitorSelfRegisteredSocketCount (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfRegisteredSocketCount = val;
        instChanged = true;
    }
    inline uint32_t get_MonitorSelfRegisteredSocketCount() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfRegisteredSocketCount;
    }
    inline void set_MonitorSelfResidentSetSize (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfResidentSetSize = val;
        instChanged = true;
    }
    inline uint32_t get_MonitorSelfResidentSetSize() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfResidentSetSize;
    }
    inline void set_MonitorSelfTime (int64_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfTime = val;
        instChanged = true;
    }
    inline int64_t get_MonitorSelfTime() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfTime;
    }

};

}}}

#endif  /*!_MANAGEMENT_MASTER_*/
