
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "qpid/agent/ManagementAgent.h"
#include "Negotiator.h"
#include "ArgsNegotiatorGetLimits.h"
#include "ArgsNegotiatorSetLimit.h"
#include "ArgsNegotiatorGetStats.h"
#include "ArgsNegotiatorSetPriority.h"
#include "ArgsNegotiatorSetPriorityFactor.h"
#include "ArgsNegotiatorSetUsage.h"
#include "ArgsNegotiatorGetRawConfig.h"
#include "ArgsNegotiatorSetRawConfig.h"


using namespace qmf::mrg::grid;
using namespace qpid::framing;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           std::string;

string  Negotiator::packageName  = string ("mrg.grid");
string  Negotiator::className    = string ("negotiator");
uint8_t Negotiator::md5Sum[16]   =
    {0x54,0x5e,0xc2,0x9a,0x7b,0x8a,0x5d,0xaa,0xce,0xb1,0x24,0x9c,0x78,0x1d,0xf0,0x25};

Negotiator::Negotiator (ManagementAgent* _agent, Manageable* _core) :
    ManagementObject(_agent, _core)
{
    
    Pool = "";
    System = "";
    Name = "";
    Machine = "";
    MyAddress = "";
    CondorPlatform = "";
    CondorVersion = "";
    DaemonStartTime = 0;
    MonitorSelfAge = 0;
    MonitorSelfCPUUsage = 0.;
    MonitorSelfImageSize = 0.;
    MonitorSelfRegisteredSocketCount = 0;
    MonitorSelfResidentSetSize = 0;
    MonitorSelfTime = 0;



}

Negotiator::~Negotiator ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Negotiator::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Negotiator::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (8); // Config Element Count
    buf.putShort       (6); // Inst Element Count
    buf.putShort       (9); // Method Count

    // Properties
    ft.clear();
    ft.setString (NAME, "Pool");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "System");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Name");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Machine");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "MyAddress");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "CondorPlatform");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The Condor platform string for the daemon's platform");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "CondorVersion");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The Condor version string for the daemon's version");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "DaemonStartTime");
    ft.setInt    (TYPE, TYPE_ABSTIME);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "nanosecond");
    ft.setString (DESC,   "Number of nanoseconds since epoch when the daemon     was started");
    buf.put (ft);


    // Statistics
    ft.clear();
    ft.setString (NAME,   "MonitorSelfAge");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfCPUUsage");
    ft.setInt    (TYPE,   TYPE_DOUBLE);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfImageSize");
    ft.setInt    (TYPE,   TYPE_DOUBLE);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfRegisteredSocketCount");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfResidentSetSize");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfTime");
    ft.setInt    (TYPE,   TYPE_ABSTIME);
    buf.put (ft);


    // Methods
    ft.clear();
    ft.setString (NAME,     "GetLimits");
    ft.setInt    (ARGCOUNT, 1);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Limits");
    ft.setInt    (TYPE,    TYPE_FTABLE);
    ft.setString (DIR,     "O");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "SetLimit");
    ft.setInt    (ARGCOUNT, 2);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Name");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Max");
    ft.setInt    (TYPE,    TYPE_DOUBLE);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "GetStats");
    ft.setInt    (ARGCOUNT, 2);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Name");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    ft.setString (DESC,    "User or group name");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Ad");
    ft.setInt    (TYPE,    TYPE_FTABLE);
    ft.setString (DIR,     "O");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "SetPriority");
    ft.setInt    (ARGCOUNT, 2);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Name");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    ft.setString (DESC,    "User or group name");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Priority");
    ft.setInt    (TYPE,    TYPE_DOUBLE);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "SetPriorityFactor");
    ft.setInt    (ARGCOUNT, 2);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Name");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    ft.setString (DESC,    "User or group name");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "PriorityFactor");
    ft.setInt    (TYPE,    TYPE_DOUBLE);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "SetUsage");
    ft.setInt    (ARGCOUNT, 2);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Name");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    ft.setString (DESC,    "User or group name");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Usage");
    ft.setInt    (TYPE,    TYPE_DOUBLE);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "GetRawConfig");
    ft.setInt    (ARGCOUNT, 2);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Name");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    ft.setString (DESC,    "Config param name");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Value");
    ft.setInt    (TYPE,    TYPE_LSTR);
    ft.setString (DIR,     "O");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "SetRawConfig");
    ft.setInt    (ARGCOUNT, 2);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Name");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    ft.setString (DESC,    "Config param name");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "Value");
    ft.setInt    (TYPE,    TYPE_LSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "Reconfig");
    ft.setInt    (ARGCOUNT, 0);
    buf.put (ft);


}



void Negotiator::writeProperties (Buffer& buf)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);

    buf.putShortString(Pool);
    buf.putShortString(System);
    buf.putShortString(Name);
    buf.putShortString(Machine);
    buf.putShortString(MyAddress);
    buf.putShortString(CondorPlatform);
    buf.putShortString(CondorVersion);
    buf.putLongLong(DaemonStartTime);

}

void Negotiator::writeStatistics (Buffer& buf, bool skipHeaders)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders)
        writeTimestamps (buf);
    buf.putLong(MonitorSelfAge);
    buf.putDouble(MonitorSelfCPUUsage);
    buf.putDouble(MonitorSelfImageSize);
    buf.putLong(MonitorSelfRegisteredSocketCount);
    buf.putLong(MonitorSelfResidentSetSize);
    buf.putLongLong(MonitorSelfTime);


    // Maintenance of hi-lo statistics


}

void Negotiator::doMethod (string& methodName, Buffer& inBuf, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "GetLimits") {
        ArgsNegotiatorGetLimits ioArgs;
        status = coreObject->ManagementMethod (METHOD_GETLIMITS, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        ioArgs.o_Limits.encode(outBuf);
        return;
    }

    if (methodName == "SetLimit") {
        ArgsNegotiatorSetLimit ioArgs;
        inBuf.getShortString(ioArgs.i_Name);
        ioArgs.i_Max = inBuf.getDouble();
        status = coreObject->ManagementMethod (METHOD_SETLIMIT, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "GetStats") {
        ArgsNegotiatorGetStats ioArgs;
        inBuf.getShortString(ioArgs.i_Name);
        status = coreObject->ManagementMethod (METHOD_GETSTATS, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        ioArgs.o_Ad.encode(outBuf);
        return;
    }

    if (methodName == "SetPriority") {
        ArgsNegotiatorSetPriority ioArgs;
        inBuf.getShortString(ioArgs.i_Name);
        ioArgs.i_Priority = inBuf.getDouble();
        status = coreObject->ManagementMethod (METHOD_SETPRIORITY, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "SetPriorityFactor") {
        ArgsNegotiatorSetPriorityFactor ioArgs;
        inBuf.getShortString(ioArgs.i_Name);
        ioArgs.i_PriorityFactor = inBuf.getDouble();
        status = coreObject->ManagementMethod (METHOD_SETPRIORITYFACTOR, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "SetUsage") {
        ArgsNegotiatorSetUsage ioArgs;
        inBuf.getShortString(ioArgs.i_Name);
        ioArgs.i_Usage = inBuf.getDouble();
        status = coreObject->ManagementMethod (METHOD_SETUSAGE, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "GetRawConfig") {
        ArgsNegotiatorGetRawConfig ioArgs;
        inBuf.getShortString(ioArgs.i_Name);
        status = coreObject->ManagementMethod (METHOD_GETRAWCONFIG, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        outBuf.putMediumString(ioArgs.o_Value);
        return;
    }

    if (methodName == "SetRawConfig") {
        ArgsNegotiatorSetRawConfig ioArgs;
        inBuf.getShortString(ioArgs.i_Name);
        inBuf.getMediumString(ioArgs.i_Value);
        status = coreObject->ManagementMethod (METHOD_SETRAWCONFIG, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "Reconfig") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_RECONFIG, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    outBuf.putLong(status);
    outBuf.putShortString(Manageable::StatusText(status, text));
}
