/*
 * Copyright 2008 Red Hat, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef _SCHEDULEROBJECT_H
#define _SCHEDULEROBJECT_H

#include <qpid/management/Manageable.h>
#include <qpid/management/ManagementObject.h>
#include <qpid/agent/ManagementAgent.h>
#include <qpid/framing/FieldTable.h>

#include "Scheduler.h"

#include "condor_classad.h"


namespace mrg {
namespace grid {

using namespace qpid::management;
using namespace qpid::framing;

class SchedulerObject : public qpid::management::Manageable
{

public:

	SchedulerObject(qpid::management::ManagementAgent *agent);

	~SchedulerObject();


	qpid::management::ManagementObject *GetManagementObject(void) const;

	void update(const ClassAd &ad);


	status_t ManagementMethod(uint32_t methodId,
							  Args &args,
							  std::string &text);

private:

	qmf::mrg::grid::Scheduler *mgmtObject;

	status_t Submit(FieldTable &ad, std::string &id, std::string &text);
};


}} /* mrg::grid */

#endif /* _SCHEDULEROBJECT_H */
