
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "qpid/agent/ManagementAgent.h"
#include "Slot.h"


using namespace qmf::mrg::grid;
using namespace qpid::framing;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           std::string;

string  Slot::packageName  = string ("mrg.grid");
string  Slot::className    = string ("slot");
uint8_t Slot::md5Sum[16]   =
    {0x95,0xb0,0x31,0x16,0x55,0x4c,0x3c,0x19,0xa,0x50,0xbb,0xc2,0xe3,0xb0,0x59,0x2};

Slot::Slot (ManagementAgent* _agent, Manageable* _core) :
    ManagementObject(_agent, _core)
{
    
    CondorPlatform = "";
    CondorVersion = "";
    DaemonStartTime = 0;
    Pool = "";
    System = "";
    AccountingGroup = "";
    Arch = "";
    CheckpointPlatform = "";
    ClientMachine = "";
    ConcurrencyLimits = "";
    Cpus = 0;
    CurrentRank = 0.;
    Disk = 0;
    FileSystemDomain = "";
    GlobalJobId = "";
    ImageSize = 0;
    IsValidCheckpointPlatform = "";
    JobId = "";
    JobStart = 0;
    KFlops = 0;
    Machine = "";
    MaxJobRetirementTime = "";
    Memory = 0;
    Mips = 0;
    MyAddress = "";
    Name = "";
    OpSys = "";
    PreemptingConcurrencyLimits = "";
    PreemptingOwner = "";
    PreemptingUser = "";
    PreemptingRank = 0.;
    RemoteOwner = "";
    RemoteUser = "";
    Requirements = "";
    PublicNetworkIpAddr = "";
    Rank = "";
    SlotID = 0;
    Start = "";
    StarterAbilityList = "";
    TotalClaimRunTime = 0;
    TotalClaimSuspendTime = 0;
    TotalCpus = 0;
    TotalDisk = 0;
    TotalJobRunTime = 0;
    TotalJobSuspendTime = 0;
    TotalMemory = 0;
    TotalSlots = 0;
    TotalVirtualMemory = 0;
    UidDomain = "";
    VirtualMemory = 0;
    WindowsBuildNumber = 0;
    WindowsMajorVersion = 0;
    WindowsMinorVersion = 0;
    MonitorSelfAge = 0;
    MonitorSelfCPUUsage = 0.;
    MonitorSelfImageSize = 0.;
    MonitorSelfRegisteredSocketCount = 0;
    MonitorSelfResidentSetSize = 0;
    MonitorSelfTime = 0;
    Activity = "";
    ClockDay = 0;
    ClockMin = 0;
    CondorLoadAvg = 0.;
    ConsoleIdle = 0;
    EnteredCurrentActivity = 0;
    EnteredCurrentState = 0;
    KeyboardIdle = 0;
    LastBenchmark = 0;
    LastFetchWorkCompleted = 0;
    LastFetchWorkSpawned = 0;
    LastPeriodicCheckpoint = 0;
    LoadAvg = 0.;
    MyCurrentTime = 0;
    NextFetchWorkDelay = 0;
    State = "";
    TimeToLive = 0;
    TotalCondorLoadAvg = 0.;
    TotalLoadAvg = 0.;
    TotalTimeBackfillBusy = 0;
    TotalTimeBackfillIdle = 0;
    TotalTimeBackfillKilling = 0;
    TotalTimeClaimedBusy = 0;
    TotalTimeClaimedIdle = 0;
    TotalTimeClaimedRetiring = 0;
    TotalTimeClaimedSuspended = 0;
    TotalTimeMatchedIdle = 0;
    TotalTimeOwnerIdle = 0;
    TotalTimePreemptingKilling = 0;
    TotalTimePreemptingVacating = 0;
    TotalTimeUnclaimedBenchmarking = 0;
    TotalTimeUnclaimedIdle = 0;


    // Optional properties start out not-present
    for (uint8_t idx = 0; idx < 3; idx++)
        presenceMask[idx] = 0;


}

Slot::~Slot ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Slot::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Slot::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (53); // Config Element Count
    buf.putShort       (38); // Inst Element Count
    buf.putShort       (0); // Method Count

    // Properties
    ft.clear();
    ft.setString (NAME, "CondorPlatform");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The Condor platform string for the daemon's platform");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "CondorVersion");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The Condor version string for the daemon's version");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "DaemonStartTime");
    ft.setInt    (TYPE, TYPE_ABSTIME);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "nanosecond");
    ft.setString (DESC,   "Number of nanoseconds since epoch when the daemon     was started");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Pool");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "System");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "AccountingGroup");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "AccountingGroup of the running job, fully       qualified with a UidDomain, UidDomain taken from       RemoteUser, only present when a job is       executing");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Arch");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Slot's architecture, e.g.: ALPHA, Diginal Alpha;       HPPA1, HP PA-RISC 1.x (7000 series); HPPA2, HP       PA-RISC 2.x (8000 series); IA64, Intel Itanium;       INTEL, Intel x86 (Pentium, Xeon, etc); SGI, SGI       MIPS; SUN4u, Sun UltraSparc; SUN4x, Sun Sparc       (not UltraSparc); PPC, Power Macintosh; PPC64,       64-bit Power Macintosh; X86_64, AMD/Intel 64-bit       x86");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "CheckpointPlatform");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Opaque string encoding OS, hardware and kernel       attributes");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "ClientMachine");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "The hostname of the machine that has claimed the       slot, only present when slot is claimed");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "ConcurrencyLimits");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "Set of concurrency limits associated with the       current job");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Cpus");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Number of CPUs in slot");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "CurrentRank");
    ft.setInt    (TYPE, TYPE_DOUBLE);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "Slots' affinity for running the job it is       currently hosting, calculated as Rank expression       evaluated in context of the running job's ad");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Disk");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "KiB");
    ft.setString (DESC,   "Amount of disk space in KiB available in the slot");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "FileSystemDomain");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Configured namespace shared by slots with       uniformly mounted shared storage");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "GlobalJobId");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "The running job's GlobalJobId, only present when       a job is executing");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "ImageSize");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (UNIT,   "KiB");
    ft.setString (DESC,   "Estimate of the memory image size, in KiB, of the       running job, only present when a job is       executing, pulled by STARTD_JOB_EXPRS");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "IsValidCheckpointPlatform");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "A configurable expression representing if a       checkpointed job can run on the slot, part of the       slot's Requirements along with the Start       expression");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "JobId");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "The running job's identifier,       i.e. ClusterId.ProcId, only present when a job is       executing");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "JobStart");
    ft.setInt    (TYPE, TYPE_ABSTIME);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (UNIT,   "nanosecond");
    ft.setString (DESC,   "The number of nanosecond since epoch when the job       began executing, only present when a job is       executing");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "KFlops");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Relative floating point performance on a Linpack       benchmark");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Machine");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The fully qualified hostname of slot's host       machine");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "MaxJobRetirementTime");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Expression evaluated in context of job ad       producing the number of seconds a job is allowed       to finish before being killed, relevant when job       is being kicked out of the slot");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Memory");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "MiB");
    ft.setString (DESC,   "Amount of RAM available in the slot, in MiB");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Mips");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Relative integer performance on a Dhrystone       benchmark");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "MyAddress");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "IP:Port of StartD in charge of the slot");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Name");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Name of the slot, either the same as Machine,       slot#@Machine, or a configured value");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "OpSys");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Slot's operating system, e.g.: HPUX10, HPUX       10.20; HPUX11, HPUX B.11.00; LINUX, Linux       2.[0,2,4,6].x kernels; OSF1, Diginal Unix 4.x;       OSX, Darwin; OSX10_2, Darwin 6.4; SOLARIS25,       Solaris 2.4 or 5.5; SOLARIS251, Solaris 2.5.1 or       5.5.1; SOLARIS26, Solaris 2.6 or 5.6; SOLARIS27,       Solaris 2.7 or 5.7; SOLARIS28, Solaris 2.8 or       5.8; SOLARIS29, Solaris 2.9 or 5.9; WINNT50,       Windows 2000; WINNT51, Windows XP; WINNT52,       Windows Server 2003; WINNT60, Windows Vista");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "PreemptingConcurrencyLimits");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "Set of concurrency limits associated with the       preempting job");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "PreemptingOwner");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "The name of the user originally preempting the       current job, i.e. the incoming user, only present       when slot is claimed");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "PreemptingUser");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "The name of the user preempting the current job,       different from PreemptingOwner only if the claim       was given to another user who is using it to       preempt, only present when slot is claimed");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "PreemptingRank");
    ft.setInt    (TYPE, TYPE_DOUBLE);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "Slots' affinity for running the incoming,       preempting, job, calculated as Rank expression       evaluated in context of the incoming job's ad,       only present when slot is claimed");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "RemoteOwner");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "The name of the user who originally claimed the       slot, only present when slot is claimed");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "RemoteUser");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (DESC,   "The name of the user who is currently using the       slot, different from RemoteOwner only if the       claim was given to another user who is using the       slot, only present when slot is claimed");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Requirements");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Expression evaluated in the context of a job ad       to determine if the slot will run a job");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "PublicNetworkIpAddr");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "IP:Port used to communicate with the slot");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Rank");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Configured expression representing how the slot       prefers jobs");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "SlotID");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The # in the slot's Name, i.e. Name='slot#@Machine'");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "Start");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Expression evaluated to determine if a slot is       willing to start running a job");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "StarterAbilityList");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "StringList, comma separated, set of abilities the       slot has, i.e. HasFileTransfer,HasJava,HasVM,       query with stringListMember('Element',       StarterAbilityList)");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "TotalClaimRunTime");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Number of seconds the current claim has spent       running jobs, only present when slot is       claimed");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "TotalClaimSuspendTime");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Number of seconds the current claim has spent       with suspended jobs, only present when slot is       claimed");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "TotalCpus");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Total number of CPUs on slot's host machine, or       NUM_CPUS configuration option");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "TotalDisk");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "KiB");
    ft.setString (DESC,   "Amount of disk space available on the slot's host       machine");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "TotalJobRunTime");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Number of seconds the current job has spent       running, i.e. Claimed/Busy, only present when       slot is claimed");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "TotalJobSuspendTime");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Number of seconds the current job has spent       suspended, i.e. Claimed/Suspended, only present       when slot is claimed");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "TotalMemory");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "MiB");
    ft.setString (DESC,   "Total RAM available on slot's machine, in MiB");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "TotalSlots");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Total number of slots sharing the Machine");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "TotalVirtualMemory");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "KiB");
    ft.setString (DESC,   "Amount of swap space available on slot");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "UidDomain");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Configured namespace shared by slots with       uniform uid/gid entries, i.e. same logins and       groups");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "VirtualMemory");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "KiB");
    ft.setString (DESC,   "Amount of currently available virtual memory       (swap space) in KiB");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "WindowsBuildNumber");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Integer extracted from the platform type,       representing a build number for a Windows       operating system, only present on Windows       slots");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "WindowsMajorVersion");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Integer extracted from the platform type,       representing a major version number for a Windows       operating system, only present on Windows       slots, e.g. 5 for OpSys=WINNT50");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "WindowsMinorVersion");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Integer extected from the platform type,       representing a minor version numer for a Windows       operating system, only present on Windows       slots, e.g. 2 for OpSys=WINNT52");
    buf.put (ft);


    // Statistics
    ft.clear();
    ft.setString (NAME,   "MonitorSelfAge");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfCPUUsage");
    ft.setInt    (TYPE,   TYPE_DOUBLE);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfImageSize");
    ft.setInt    (TYPE,   TYPE_DOUBLE);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfRegisteredSocketCount");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfResidentSetSize");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MonitorSelfTime");
    ft.setInt    (TYPE,   TYPE_ABSTIME);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "Activity");
    ft.setInt    (TYPE,   TYPE_SSTR);
    ft.setString (DESC,   "One of: Idle, No job activity; Busy, Job is        running; Suspended, Job is suspended; Vacating,        Job is being removed; Killing, Job is being        killed; Benchmarking, Benchmarks being run");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "ClockDay");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (DESC,   "Day of the week: 0 = Sunday, 1 = Monday, ..., 6 =        Saturaday");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "ClockMin");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "minute");
    ft.setString (DESC,   "Number of elapsed minutes since midnight");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "CondorLoadAvg");
    ft.setInt    (TYPE,   TYPE_DOUBLE);
    ft.setString (DESC,   "Portion of LoadAvg generated by Condor (job or        benchmark)");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "ConsoleIdle");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Seconds since activity on console keyboard or        mouse");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "EnteredCurrentActivity");
    ft.setInt    (TYPE,   TYPE_ABSTIME);
    ft.setString (UNIT,   "nanosecond");
    ft.setString (DESC,   "Time at which current Activity was entered,        number of nanoseconds since Unix epoch");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "EnteredCurrentState");
    ft.setInt    (TYPE,   TYPE_ABSTIME);
    ft.setString (UNIT,   "nanosecond");
    ft.setString (DESC,   "Time at which current State was entered,        number of seconds since Unix epoch");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "KeyboardIdle");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Number of seconds since any activity on any        keyboard or mouse associated with the machine,        including pseudo-terminals");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "LastBenchmark");
    ft.setInt    (TYPE,   TYPE_ABSTIME);
    ft.setString (UNIT,   "nanosecond");
    ft.setString (DESC,   "Number of nanoseconds since epoch when the last        benchmark was run");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "LastFetchWorkCompleted");
    ft.setInt    (TYPE,   TYPE_ABSTIME);
    ft.setString (UNIT,   "nanosecond");
    ft.setString (DESC,   "Number of nanoseconds since epoch when the        FetchWork Hook returned");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "LastFetchWorkSpawned");
    ft.setInt    (TYPE,   TYPE_ABSTIME);
    ft.setString (UNIT,   "nanosecond");
    ft.setString (DESC,   "Number of nanoseconds since epoch when the        FetchWork Hook was invoked");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "LastPeriodicCheckpoint");
    ft.setInt    (TYPE,   TYPE_ABSTIME);
    ft.setString (UNIT,   "nanosecond");
    ft.setString (DESC,   "The number of nanoseconds since epoch when the        job last performed a periodic checkpoint, only        present when a job is executing");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "LoadAvg");
    ft.setInt    (TYPE,   TYPE_DOUBLE);
    ft.setString (DESC,   "Load average of CPUs hosting the slot");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "MyCurrentTime");
    ft.setInt    (TYPE,   TYPE_ABSTIME);
    ft.setString (UNIT,   "nanosecond");
    ft.setString (DESC,   "The number of nanoseconds since epoch that the        slot produced an updated ad");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "NextFetchWorkDelay");
    ft.setInt    (TYPE,   TYPE_S32);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Number of seconds until the next FetchWork        Hook will be invoked, -1 means never");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "State");
    ft.setInt    (TYPE,   TYPE_SSTR);
    ft.setString (DESC,   "One of: Owner, unavailable to Condor; Unclaimed,        available to Condor, but no job match yet;        Matched, job found, but not yet claimed; Claimed,        claimed and job likely running (see Activity);        Preempting, running job is being kicked off the        slot");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TimeToLive");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Number of second until StartD managing the slot        has until it will exit");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalCondorLoadAvg");
    ft.setInt    (TYPE,   TYPE_DOUBLE);
    ft.setString (DESC,   "Portion of TotalLoadAvg generated by Condor (jobs        or benchmarks)");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalLoadAvg");
    ft.setInt    (TYPE,   TYPE_DOUBLE);
    ft.setString (DESC,   "Total load average of the slot's host machine");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalTimeBackfillBusy");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Accumulated number of seconds the slot has been        in State=Backfill and Activity=Busy since the        Startd started");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalTimeBackfillIdle");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Accumulated number of seconds the slot has been        in State=Backfill and Activity=Idle since the        Startd started");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalTimeBackfillKilling");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Accumulated number of seconds the slot has been        in State=Backfill and Activity=Killing since the        Startd started");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalTimeClaimedBusy");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Accumulated number of seconds the slot has been        in State=Claimed and Activity=Busy since the        Startd started");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalTimeClaimedIdle");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Accumulated number of seconds the slot has been        in State=Claimed and Activity=Idle since the        Startd started");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalTimeClaimedRetiring");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Accumulated number of seconds the slot has been        in State=Claimed and Activity=Retiring since the        Startd started");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalTimeClaimedSuspended");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Accumulated number of seconds the slot has been        in State=Claimed and Activity=Suspended since the        Startd started");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalTimeMatchedIdle");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Accumulated number of seconds the slot has been        in State=Matched and Activity=Idle since the        Startd started");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalTimeOwnerIdle");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Accumulated number of seconds the slot has been        in State=Owner and Activity=Idle since the        Startd started");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalTimePreemptingKilling");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Accumulated number of seconds the slot has been        in State=Preempting and Activity=Killing since the        Startd started");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalTimePreemptingVacating");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Accumulated number of seconds the slot has been        in State=Preempting and Activity=Vacating since the        Startd started");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalTimeUnclaimedBenchmarking");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Accumulated number of seconds the slot has been        in State=Unclaimed and Activity=Benchmarking since        the Startd started");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "TotalTimeUnclaimedIdle");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "second");
    ft.setString (DESC,   "Accumulated number of seconds the slot has been        in State=Unclaimed and Activity=Idle since the        Startd started");
    buf.put (ft);


    // Methods

}



void Slot::writeProperties (Buffer& buf)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);

    for (uint8_t idx = 0; idx < 3; idx++)
        buf.putOctet(presenceMask[idx]);

    buf.putShortString(CondorPlatform);
    buf.putShortString(CondorVersion);
    buf.putLongLong(DaemonStartTime);
    buf.putShortString(Pool);
    buf.putShortString(System);
    if (presenceMask[presenceByte_AccountingGroup] & presenceMask_AccountingGroup) {
        buf.putShortString(AccountingGroup);
    }
    buf.putShortString(Arch);
    buf.putShortString(CheckpointPlatform);
    if (presenceMask[presenceByte_ClientMachine] & presenceMask_ClientMachine) {
        buf.putShortString(ClientMachine);
    }
    if (presenceMask[presenceByte_ConcurrencyLimits] & presenceMask_ConcurrencyLimits) {
        buf.putShortString(ConcurrencyLimits);
    }
    buf.putLong(Cpus);
    if (presenceMask[presenceByte_CurrentRank] & presenceMask_CurrentRank) {
        buf.putDouble(CurrentRank);
    }
    buf.putLong(Disk);
    buf.putShortString(FileSystemDomain);
    if (presenceMask[presenceByte_GlobalJobId] & presenceMask_GlobalJobId) {
        buf.putShortString(GlobalJobId);
    }
    if (presenceMask[presenceByte_ImageSize] & presenceMask_ImageSize) {
        buf.putLong(ImageSize);
    }
    buf.putMediumString(IsValidCheckpointPlatform);
    if (presenceMask[presenceByte_JobId] & presenceMask_JobId) {
        buf.putShortString(JobId);
    }
    if (presenceMask[presenceByte_JobStart] & presenceMask_JobStart) {
        buf.putLongLong(JobStart);
    }
    buf.putLong(KFlops);
    buf.putShortString(Machine);
    buf.putMediumString(MaxJobRetirementTime);
    buf.putLong(Memory);
    buf.putLong(Mips);
    buf.putShortString(MyAddress);
    buf.putShortString(Name);
    buf.putShortString(OpSys);
    if (presenceMask[presenceByte_PreemptingConcurrencyLimits] & presenceMask_PreemptingConcurrencyLimits) {
        buf.putShortString(PreemptingConcurrencyLimits);
    }
    if (presenceMask[presenceByte_PreemptingOwner] & presenceMask_PreemptingOwner) {
        buf.putShortString(PreemptingOwner);
    }
    if (presenceMask[presenceByte_PreemptingUser] & presenceMask_PreemptingUser) {
        buf.putShortString(PreemptingUser);
    }
    if (presenceMask[presenceByte_PreemptingRank] & presenceMask_PreemptingRank) {
        buf.putDouble(PreemptingRank);
    }
    if (presenceMask[presenceByte_RemoteOwner] & presenceMask_RemoteOwner) {
        buf.putShortString(RemoteOwner);
    }
    if (presenceMask[presenceByte_RemoteUser] & presenceMask_RemoteUser) {
        buf.putShortString(RemoteUser);
    }
    buf.putMediumString(Requirements);
    buf.putShortString(PublicNetworkIpAddr);
    buf.putMediumString(Rank);
    buf.putLong(SlotID);
    buf.putMediumString(Start);
    buf.putMediumString(StarterAbilityList);
    if (presenceMask[presenceByte_TotalClaimRunTime] & presenceMask_TotalClaimRunTime) {
        buf.putLong(TotalClaimRunTime);
    }
    if (presenceMask[presenceByte_TotalClaimSuspendTime] & presenceMask_TotalClaimSuspendTime) {
        buf.putLong(TotalClaimSuspendTime);
    }
    buf.putLong(TotalCpus);
    buf.putLong(TotalDisk);
    if (presenceMask[presenceByte_TotalJobRunTime] & presenceMask_TotalJobRunTime) {
        buf.putLong(TotalJobRunTime);
    }
    if (presenceMask[presenceByte_TotalJobSuspendTime] & presenceMask_TotalJobSuspendTime) {
        buf.putLong(TotalJobSuspendTime);
    }
    buf.putLong(TotalMemory);
    buf.putLong(TotalSlots);
    buf.putLong(TotalVirtualMemory);
    buf.putShortString(UidDomain);
    buf.putLong(VirtualMemory);
    buf.putLong(WindowsBuildNumber);
    buf.putLong(WindowsMajorVersion);
    buf.putLong(WindowsMinorVersion);

}

void Slot::writeStatistics (Buffer& buf, bool skipHeaders)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders)
        writeTimestamps (buf);
    buf.putLong(MonitorSelfAge);
    buf.putDouble(MonitorSelfCPUUsage);
    buf.putDouble(MonitorSelfImageSize);
    buf.putLong(MonitorSelfRegisteredSocketCount);
    buf.putLong(MonitorSelfResidentSetSize);
    buf.putLongLong(MonitorSelfTime);
    buf.putShortString(Activity);
    buf.putLong(ClockDay);
    buf.putLong(ClockMin);
    buf.putDouble(CondorLoadAvg);
    buf.putLong(ConsoleIdle);
    buf.putLongLong(EnteredCurrentActivity);
    buf.putLongLong(EnteredCurrentState);
    buf.putLong(KeyboardIdle);
    buf.putLongLong(LastBenchmark);
    buf.putLongLong(LastFetchWorkCompleted);
    buf.putLongLong(LastFetchWorkSpawned);
    buf.putLongLong(LastPeriodicCheckpoint);
    buf.putDouble(LoadAvg);
    buf.putLongLong(MyCurrentTime);
    buf.putInt32(NextFetchWorkDelay);
    buf.putShortString(State);
    buf.putLong(TimeToLive);
    buf.putDouble(TotalCondorLoadAvg);
    buf.putDouble(TotalLoadAvg);
    buf.putLong(TotalTimeBackfillBusy);
    buf.putLong(TotalTimeBackfillIdle);
    buf.putLong(TotalTimeBackfillKilling);
    buf.putLong(TotalTimeClaimedBusy);
    buf.putLong(TotalTimeClaimedIdle);
    buf.putLong(TotalTimeClaimedRetiring);
    buf.putLong(TotalTimeClaimedSuspended);
    buf.putLong(TotalTimeMatchedIdle);
    buf.putLong(TotalTimeOwnerIdle);
    buf.putLong(TotalTimePreemptingKilling);
    buf.putLong(TotalTimePreemptingVacating);
    buf.putLong(TotalTimeUnclaimedBenchmarking);
    buf.putLong(TotalTimeUnclaimedIdle);


    // Maintenance of hi-lo statistics


}

void Slot::doMethod (string&, Buffer&, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    outBuf.putLong(status);
    outBuf.putShortString(Manageable::StatusText(status, text));
}
