
#ifndef _MANAGEMENT_SUBMITTER_
#define _MANAGEMENT_SUBMITTER_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/Uuid.h"

namespace qmf {
namespace mrg {
namespace grid {


class Submitter : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[16];


    // Properties
    ::qpid::management::ObjectId schedulerRef;
    int64_t JobQueueBirthdate;
    std::string Machine;
    std::string Name;
    std::string ScheddName;

    // Statistics
    uint32_t  HeldJobs;
    uint32_t  IdleJobs;
    uint32_t  RunningJobs;


    // Private Methods
    static void writeSchema(::qpid::framing::Buffer& buf);
    void writeProperties(::qpid::framing::Buffer& buf);
    void writeStatistics(::qpid::framing::Buffer& buf,
                         bool skipHeaders = false);
    void doMethod(std::string& methodName,
                  ::qpid::framing::Buffer& inBuf,
                  ::qpid::framing::Buffer& outBuf);
    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }

  public:

    Submitter(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject, ::qpid::management::Manageable* _parent);
    ~Submitter();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs

    // Accessor Methods
    inline void set_schedulerRef (const ::qpid::management::ObjectId& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        schedulerRef = val;
        configChanged = true;
    }
    inline const ::qpid::management::ObjectId& get_schedulerRef() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return schedulerRef;
    }
    inline void set_JobQueueBirthdate (int64_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        JobQueueBirthdate = val;
        configChanged = true;
    }
    inline int64_t get_JobQueueBirthdate() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return JobQueueBirthdate;
    }
    inline void set_Machine (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        Machine = val;
        configChanged = true;
    }
    inline const std::string& get_Machine() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return Machine;
    }
    inline void set_Name (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        Name = val;
        configChanged = true;
    }
    inline const std::string& get_Name() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return Name;
    }
    inline void set_ScheddName (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        ScheddName = val;
        configChanged = true;
    }
    inline const std::string& get_ScheddName() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return ScheddName;
    }
    inline void set_HeldJobs (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        HeldJobs = val;
        instChanged = true;
    }
    inline uint32_t get_HeldJobs() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return HeldJobs;
    }
    inline void set_IdleJobs (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        IdleJobs = val;
        instChanged = true;
    }
    inline uint32_t get_IdleJobs() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return IdleJobs;
    }
    inline void set_RunningJobs (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        RunningJobs = val;
        instChanged = true;
    }
    inline uint32_t get_RunningJobs() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return RunningJobs;
    }

};

}}}

#endif  /*!_MANAGEMENT_SUBMITTER_*/
